
jQuery(function($){

	var SlidedeckHotspot = {

		$el : $( "#slidedeck-hotspot-accordion" ),

		init : function(){
			this.createAccordion();
			this.events();
		},

		events : function(){
			var post_id;
			var _this = this;
			var views;
			this.$el.find('.slidedeck-hotspot-handle').on( 'click', function(){

				if( $(this).next('.slidedeck-hotspot-slider-content').find('.slidedeck-hotspots-table').length || $(this).data('views') === 0 ) return;

				post_id = $(this).data('post-id');
				_this.pull( post_id , $(this) );
			});
		},

		createAccordion : function(){
			this.$el.accordion({
				header : '.slidedeck-hotspot-handle',
				collapsible: true,
				active: false,
				heightStyle: "content",
			    navigation: true
			});
		},

		pull : function( post_id, $this ){

			$.ajax({
				url: ajaxurl,
				type: 'POST',
				dataType: 'json',
				data: {
					'action' : 'slidedeck_pull_stats',
					'post_id' : post_id
				},
			})
			.done(function( resp ) {
				var $markup = $(resp.html);
				$this.next('.slidedeck-hotspot-slider-content').html( $markup );
				$markup.hide().fadeIn('slow');
			})
			.fail(function() {
				console.log("error");
			})
			.always(function() {
				console.log("complete");
			});
		},

	};

	SlidedeckHotspot.init();

});