<?php
	/**
	 * Used on slidedeck hotspot admin page.
	 * @package Slidedeck
	 */
 ?>

<div id="slidedeck-hotspot-stats" class="slidedeck-hotspot-stats">
	<div class="wrap">
		<header class="slidedeck-header">
            <h1><?php _e( "Slidedeck Lead Generation Stats" ); ?></h1>
        </header>
        <div id="slidedeck-lenses-wrapper">

    		<?php echo $this->render( 'stats-settings' ); ?>

	        <div id="slidedeck-hotspot-accordion" class="slidedeck-hotspot-accordion">
	        <?php
        		$args = array(
        						'posts_per_page'      => 100,
        						'ignore_sticky_posts' => true,
        						'post_status'         => 'publish',
        						'orderby'             => 'date',
        						'order'               => 'DESC',
								'post_type' 		  => 'sdslide'
        					);

				$query      = new WP_Query( $args );
				$table_name = $this->get_table_name();
        		global $wpdb;

        		if ( $query->have_posts() ) : while ( $query->have_posts() ) : $query->the_post();
        			$post_id = get_the_ID();
        			$view_count_data = $wpdb->get_results(
                        "SELECT caption, COUNT( slide_index ) as count
                        FROM  {$table_name}
                        WHERE post_id = {$post_id}
                        AND ACTION =  'view'
                        GROUP BY slide_index"
                        , OBJECT
        			);

                    $view_count =  isset( $view_count_data[0] ) ? $view_count_data[0]->count : 0;


                    $click_count_data = $wpdb->get_results(
                        "SELECT caption, COUNT( slide_index ) as view_count
                        FROM  {$table_name}
                        WHERE post_id = {$post_id}
                        AND ACTION =  'click'
                        GROUP BY slide_index"
                        , OBJECT
                    );

                    $click_count =  isset( $click_count_data[0] ) ? $click_count_data[0]->view_count : 0;

          		    ?>

        			<div class="slidedeck-hotspot-handle" data-post-id="<?php echo $post_id; ?>" data-views="<?php echo $count; ?>" >
        				<?php the_title("<h3>", "</h3>"); ?>
        				<!-- <span class='sh-views'><?php _e( 'Views : ', 'slidedeck' ); ?> <?php echo $count; ?></span> -->
        			</div>
        			<div class="slidedeck-hotspot-slider-content">
                        <span class="spinner"></span>
        			</div>
        		<?php endwhile; endif; wp_reset_postdata(); ?>
	        </div>

		</div>
	</div>
</div>
