
/**
 * SlideDeck Lens Admin Scripts
 *
 * This script file will be loaded automatically in the SlideDeck edit view
 * of the WordPress control panel when this lens is chosen.
 *
 * You must include all your JavaScript in the SlideDeckLensAdmin[LENS_SLUG]
 * function, or it will not be run when the Lens is chosen in real time by
 * the user in the editing view.
 */

jQuery(function($){

	if( typeof SDLayerPro !== 'undefined' ) return;

	window.SDLayerPro = {

		$currentEditor : false,

		init : function(){
			this.imageUploader();
			this.events();
		},

		events : function(){
			$('body').on( 'click' , '.sdl-cross' , this.removeImage  );
			$('body').on( 'change' , '#sdl-checkbox-just-effect', this.showScrollContent );
			$('body').on( 'change' , '#sdl-checkbox-layers', this.showLayerMoveContent );
			$('body').on( 'click' , '#slidedeck-section-lenses label.lens', this.addLensClasses );
			$('#slidedeck-section-header').on( 'slideEditorOpen' , this.onEditorOpen );
			$('#slidedeck-preview').on('load', this.createLSliderLoadedEvent );
			$('#slidedeck-preview').on('layerproSlideisReady', this.onLayerProSlideReady );
			$('body').on('click', '#slidedeck-section-options' , this.hideOptions );
			$('body').on( 'click', '#slidedeck-content-control .slide', this.setCurrentEditor );
			$(document).on('ready', this.hideOptions);
			$(window).on('load', this.hideOptions);
                        $('.sd_add_layers').addClass('sdl-hide');
                        
		},

		showScrollContent : function(){
			$('.sdl-add-layer ').addClass('sdl-hide');
			$('.sdl-scroll-layers').removeClass('sdl-hide').fadeIn();
			$('.sdl_layerpro_type_field').val('scroll');
		},

		showLayerMoveContent : function(){
			//$('.sdl-scroll-layers').addClass('sdl-hide');
			$('.sdl-add-layers').removeClass('sdl-hide').fadeIn();
			$('.sdl_layerpro_type_field').val('layermove');
		},

		setCurrentEditor : function(){
			SDLayerPro.$currentEditor = $(this);
		},

		hideOptions : function(){

			var $mainForm = $('#slidedeck-update-form');

			if( SDLayerPro.isLayerPro() ){
				$mainForm.addClass('is-layerpro-lens');
			}
			else{
				$mainForm.removeClass('is-layerpro-lens');
			}

			SDLayerPro.removeOtherSlideEditors();
		},

		removeImage : function()
		{
			var $parentLi = $(this).closest('.sdl-right');
                        var sdlRightLength = $('.sdl-right').length;
                         var cn = ".sd-li-"+$parentLi.data('value');
			$(cn).find('.sdl-attachment-id').val('');
			$(cn).find('.sdl-url').text('');
			$(cn).find('.sdl-thumbnail').html( '' );
			$(cn).removeClass('sdl_has_thumb');
                        $(cn).find('.sd-text-box').val('');
			$parentLi.find('.sd-text-box').attr('value','');
                        $(this).closest('.sdl-right').hide();
                        $(cn).hide();
		},

		imageUploader : function(){

			var $this, image, imageData, uploaded_image, $parentLi, attachment_id, thumbnail;

		    $('body').on( 'click' , '.sdl-uploader' , function(e) {
				e.preventDefault();
				$this = $(this);
		        image = wp.media({
		            title: 'Upload Slide Image',
		            // mutiple: true if you want to upload multiple files at once
		            multiple: false
		        }).open()
		        .on('select', function(e){
		            // This will return the selected image from the Media Uploader, the result is an object
		            uploaded_image = image.state().get('selection').first();
		            // We convert uploaded_image to a JSON object to make accessing it easier
		            // Output to the console uploaded_image
		            imageData = uploaded_image.toJSON();

		            if( $.inArray( imageData.subtype , [ 'jpg','png','PNG','JPG','JPEG', 'jpeg', 'gif' ,'GIF' ] ) < 0 ){
		            	alert("Sorry, You can only upload images in this lens.");
		            	return;
		            }
		            if(!imageData.sizes.thumbnail ) {
                        thumbnail = imageData.subtype === 'gif' ? imageData.url : imageData.sizes.full.url;
					} else {
                        thumbnail = imageData.subtype === 'gif' ? imageData.url : imageData.sizes.thumbnail.url;
					}


	            	$parentLi = $this.closest('li');

	            	attachment_id = imageData.id;

		            // Let's assign the url value to the input field
		            $parentLi.find('.sdl-attachment-id').val(attachment_id);
		            $parentLi.find('.sdl-url').text( imageData.name + '.' + imageData.subtype );
		            $parentLi.addClass('sdl_has_thumb');
                            
		            $parentLi.find('.sdl-thumbnail').html( '<img src=" ' + thumbnail + ' " >' );
		        });
		    });
		},

		isLayerPro : function(){
			var currentLens = $('#slidedeck-section-lenses').find('label.lens.selected').find('span.title').text().trim();
			return currentLens === 'LayerPro';
		},

		onEditorOpen : function( e, editor ){

			if( ! SDLayerPro.isLayerPro() ) return;

			SDLayerPro.showMessage( e, editor );

			//Show hide radio content
			var $editor = $(editor);
			var $checkbox = $editor.find('.sdl-slide-checkboxes');

			//Add Class
			$editor.addClass('sdl-slide-editor');

			if( $checkbox.length ){
				if( $checkbox.find("input[type='radio']:checked").val() === 'layermove' ){
					SDLayerPro.showLayerMoveContent();
				}
				else{
					SDLayerPro.showScrollContent();
				}
			}

			$('#slidedeck-choose-slide-type').addClass('sdl-slide-editor');
                        jQuery('.lp_minicolors').each( function() {
                    
                        jQuery(this).miniColors({
                            control: jQuery(this).attr('data-control') || 'hue',
                            defaultValue: jQuery(this).attr('data-defaultValue') || '',
                            format: jQuery(this).attr('data-format') || 'hex',
                            keywords: jQuery(this).attr('data-keywords') || '',
                            inline: jQuery(this).attr('data-inline') === 'true',
                            letterCase: jQuery(this).attr('data-letterCase') || 'lowercase',
                            opacity: jQuery(this).attr('data-opacity'),
                            position: jQuery(this).attr('data-position') || 'top left',
                            swatches: jQuery(this).attr('data-swatches') ? jQuery(this).attr('data-swatches').split('|') : [],
                            change: function(hex, opacity) {
                                
                                var log;
                                try {
                                    log = hex ? hex : 'transparent';
                                    if( opacity ) log += ', ' + opacity;
                                    console.log(log);
                                } catch(e) {}
                            },
                            theme: 'default'
                        });

                    });
		},

		showMessage : function( e, editor ){

			if( SDLayerPro.$currentEditor ){
				if( SDLayerPro.$currentEditor.hasClass('is-layerpro-image-only') ){
					var $header = $(editor).find('.slide-type-header');
					if( $header.length ){
						// $header.after("<p class='sdl-image-only-message'>LayerPro Lens only works with images. Please change source to Image.</p>");
					}
				}
			}
		},

		onLayerProSlideReady : function(){

			if( SDLayerPro.isLayerPro() ){
				var $iframe = $('#slidedeck-preview');
				var $slidedeck = $iframe.contents().find('.slidedeck-layerpro');
                                
				if( $slidedeck.length ){
					var slidedeckHeight = $slidedeck.height();
                                       
					$iframe.addClass('sdl-iframe');
					$('#slidedeck-slide-dimensions').hide();
                                        /*
                                        if(slidedeckHeight < 700) {
                                            slidedeckHeight = 700;
                                        }
                                        */
                                        //$iframe.height(slidedeckHeight);
                                        
					SDLayerPro.addImageCSS( $slidedeck );
				}
			}
		},

		//Cycle2's ready event is buggy and cannot be relied upon
		createLSliderLoadedEvent :function(){

			var height;
			var $iframe = $(this);
			var $slidedeck = $iframe.contents().find('.slidedeck-layerpro').find('.slidedeck-layerpro-lens');
                        
			if( ! $slidedeck.length ){
				$iframe.removeClass('.sdl-iframe');
			}

			var interval = setInterval(function(){
				if( $slidedeck.find('.sdlcycle-slide').length && $slidedeck.height() > 1 ){
                                    
                                        height = $slidedeck.height();
                                        /*
                                        if(height < 700) {
                                            height = 700;
                                            $slidedeck.height(700);
                                        }
                                        */
					setTimeout(function(){
						clearInterval(interval);
					}, 3000 );
					$iframe.trigger( 'layerproSlideisReady', height );
				}
			}, 400 );

		},

	    addImageCSS : function( $slidedeck ){

	    	var layerWidth, slidedeckWidth, widthInPercentage, left, top, zIndex;

	    	$slidedeck.each(function(){

	    		slidedeckWidth = $(window).width();

	    		$(this).find('.sdl-slide-layer').each(function(){
					layerWidth        = $(this).find('img').attr('width');
					widthInPercentage = $(this).data('width');//( layerWidth / slidedeckWidth ) * 100;
					left              = $(this).data('offsetx')  ? $(this).data('offsetx') : 20;
					top               = $(this).data('offsetx')  ? $(this).data('offsetx') : 20;
					zIndex            = $(this).data('z-index') ? $(this).data('z-index') : 20;

	    			$(this).css( {
	    				'width' : widthInPercentage + '%',
	    				'z-index' : zIndex,
	    				'left' : left + '%',
	    				'top' : top + '%'
	    			});

	    		});
	    	});
	    },

	    addLensClasses : function()
	    {
			var titlepro = $(this).find('.title').text().trim();
	    	if( titlepro == 'LayerPro' ){
	    	    $('#slidedeck-custom-slide-editor, #slidedeck-form-body').addClass('sdl-slide-editor');
	    	}else{
	    	    $('#slidedeck-custom-slide-editor, #slidedeck-form-body').removeClass('sdl-slide-editor').find('.sdl-slide-editor').removeClass('sdl-slide-editor');
	    	    $('#slidedeck-preview').removeClass('sdl-iframe');
	    	}

	    	SDLayerPro.removeOtherSlideEditors();
	    },

	    removeOtherSlideEditors : function(){
	    	if( this.isLayerPro() ){
	    		var backgroundImageSrc;
	    		$('#slidedeck-content-control').find('li.slide').each(function(){
	    			backgroundImageSrc = $(this).css('background-image');
	    			if( backgroundImageSrc.indexOf( '/textonly/' ) >= 0 || backgroundImageSrc.indexOf( '/video/' ) >= 0 || backgroundImageSrc.indexOf( '/html/' ) >= 0 ){
	    				$(this).addClass('is-layerpro-image-only');
	    			}
	    			else{
	    				$(this).removeClass('is-layerpro-image-only');
	    			}
	    		});
	    	}
	    }

	};

	SDLayerPro.init();
       
});
