
jQuery(function($){

	"use strict";

	if( window.Sdl !== undefined ) return;

	window.Sdl = {

		$slidedeck : $('.slidedeck-layerpro-lens'),
		options : {},
		$next : $('.slidedeck-layerpro .deck-navigation.horizontal.nextp'),
		$prev : $('.slidedeck-layerpro .deck-navigation.horizontal.prevp'),

		init : function(id){
		    this.$slidedeck = $('#'+id);
			if( this.$slidedeck === undefined ) return;
			this.createLSlider();
                        var $nextSlide = jQuery('.slidedeck-layerpro').find('.sdlcycle-slide-active');
                        $nextSlide = ! $nextSlide.length ?  jQuery('.slidedeck-layerpro').find('li.slide').eq(1) : $nextSlide;
                        this.addImageCSS($nextSlide);

			this.createMouseLayerPro();
			this.events();
                        if(jQuery('.slidedeck-fullwidth-wrapper').length > 0)
                            this.fullwidth();
		},  
                fullwidth : function() {
                    var parent_frame = jQuery('.slidedeck-fullwidth-wrapper');
                    var slidedeck_width = jQuery( window ).width(); 
                    parent_frame.css({
                       "position" : "absolute",
                       "width" : slidedeck_width,
                       "max-width" : slidedeck_width,
                       "left" : ( 0 - jQuery('.slidedeck-fullwidth-wrapper').parent().offset().left ) + "px"
                    });
                    
                    var parent_style = parent_frame.attr('style');
                    parent_frame.attr( 'style', parent_style + 'width: ' + slidedeck_width + 'px !important;');
                    
                    jQuery('.slidedeck-layerpro').css({'width': slidedeck_width+'px','height':"auto",'left':( 0 - parent_frame.offset().left ) + 'px'});
		    		
		    jQuery('.slidedeck-layerpro').find("ul li.slide").addClass("sd-fullwidth-active");
		    jQuery('.slidedeck-layerpro').find(".sd-fullwidth-active").css({'width': slidedeck_width + 'px !important' , 'margin-top' : 0+'px'}); 	
                   var parent_frame_height;
                   if(slidedeck_width < 700) {
                       parent_frame_height = parent_frame.find('img').height()+40;
                   } else {
                       parent_frame_height = jQuery('.slidedeck-layerpro').height() + 40
                   }
		    		
                    if( !jQuery( ".slidedeck-fullwidth-container" ).length ) {
                        parent_frame.after('<div class="slidedeck-fullwidth-container" style="width: 100%; height: ' + ( parent_frame_height ) + 'px;"></div>');
                    }
                },

		events : function(){
			this.$slidedeck.on( 'sdlcycle-next', this.next );
			this.$slidedeck.on( 'sdlcycle-prev', this.prev );
			$(window).on( 'load', this.showSlidedeck );
                        var $nextSlide = jQuery('.slidedeck-layerpro').find('.sdlcycle-slide-active');
                        $nextSlide = ! $nextSlide.length ?  jQuery('.slidedeck-layerpro').find('li.slide').eq(1) : $nextSlide;

			$(document).on( 'keyup', this.keyboard );
                        
                        var $curSlide = this.$slidedeck.find('.sdlcycle-slide-active');
			$curSlide = ! $curSlide.length ? this.$slidedeck.find('li.slide').eq(1) : $curSlide;
			this.animateLayers( $curSlide );
		},

		showSlidedeck : function(){
			var _this = Sdl;
			$('.slidedeck-layerpro.sdl-loading').removeClass('sdl-loading');
			$(window).on('scroll', _this.createScrollLayerPro );
		},

		addNavMarkup : function( $slide, $el ){
			var imageSrc = $slide.find('.sd2-slide-background').data('fullsrc');
			$el.html( "<span class='sdl-nav-icon'></span><img src='" + imageSrc + "'>" );
		},

		addNextNav : function( next ){
			var $nextSlide = this.$slidedeck.find('.sdlcycle-slide-active').next();
			$nextSlide = ! $nextSlide.length ? this.$slidedeck.find('li.slide').eq(1) : $nextSlide;
			this.addNavMarkup( $nextSlide, this.$next() );
		},

		addPrevNav : function( currentIndex ){
			var $prevSlide = this.$slidedeck.find('.sdlcycle-slide-active').prev();
			if( $prevSlide.hasClass('.sdlcycle-sentinel') ){
				$prevSlide = this.$slidedeck.find('li.slide').last();
			}
			this.addNavMarkup( $prevSlide, this.$prev );
		},

		next : function( event, obj ){

			//Sdl.addNextNav();
		},

		prev : function( event, obj ){
			//Sdl.addPrevNav();
		},

		keyboard : function(event){

			var $slider = Sdl.$slidedeck;

			if( ! $slider.length || ! Sdl.options.keys  ) return;

			if (event.keyCode == 37) {
	           $slider.sdlcycle('prev');
	        } else if (event.keyCode == 39) {
	           $slider.sdlcycle('next');
		    }
		},

		addHoverClass : function(){
			var options = this.getSliderOptions();
			if( options.display_nav_arrows ){
				$('.slidedeck-layerpro').addClass( 'sdl-arrow-' + options.display_nav_arrows );
			}
		},

		getSliderOptions : function(){
			var $el;
			this.$slidedeck.find('.slide').each(function(){
				if( $(this).find('ul.sdl-layers').length ){
					$el = $(this).find('ul.sdl-layers');
				}
			});

			if( $el === undefined ) return {};

			return {
				'continueScrolling'  : $el.data('continuescrolling'),
				'autoPlay'           : $el.data('autoplay'),
				'autoPlayInterval'   : $el.data('autoplayinterval'),
				'cycle'              : $el.data('cycle'),
				'slideTransition'    : $el.data('slidetransition'),
				'speed'              : $el.data('speed'),
				'keys'               : $el.data('keys'),
				'touch'              : $el.data('touch'),
				'scroll'             : $el.data('scroll'),
				'start'              : $el.data('start'),
				'display_nav_arrows' : $el.data('display-nav-arrows'),
			};
		},
//this function will actually create animation for the slider
// we are using cycle2.js for the cycle animation
		createLSlider : function(){

			try{
                            this.options = this.getSliderOptions();
                            $.fn.sdlcycle.transitions.scrollTransition = {
                                    
                            before: function( a, b, c, d ) {

                                a.API.stackSlides(b, c, d);
                                var e = a.container.css("overflow", "hidden").width();
                                a.cssBefore = {
                                    left: d ? e : -e,
                                    top: 0,
                                    opacity: 1,
                                    visibility: "visible",
                                    display: "block"
                                }, a.cssAfter = {
                                    zIndex: a._maxZ - 2,
                                    left: 0
                                }, a.animIn = {
                                    left: 0
                                }, a.animOut = {
                                    left: d ? -e : e
                                }
                                var $nextSlide = jQuery('.slidedeck-layerpro').find('.sdlcycle-slide-active');
                                $nextSlide = ! $nextSlide.length ?  jQuery('.slidedeck-layerpro').find('li.slide').eq(1) : $nextSlide;
                                //window.Sdl.addImageCSS(jQuery('.slidedeck-layerpro').find('.sdlcycle-slide'));
                                window.Sdl.addImageCSS(jQuery('.slidedeck-layerpro').find('.sdlcycle-slide'));
                                window.Sdl.animateLayers( $nextSlide );
                                
                                // assign properties to the opts object
                            },
                            after: function( opts, curr, next, fwd ) {
                                // assign properties to the opts object
                                var $nextSlide = jQuery('.slidedeck-layerpro').find('.sdlcycle-slide-active');
                                $nextSlide = ! $nextSlide.length ?  jQuery('.slidedeck-layerpro').find('li.slide').eq(1) : $nextSlide;
                                window.Sdl.addImageCSS(jQuery('.slidedeck-layerpro').find('.sdlcycle-slide'));
                                //window.Sdl.addImageCSS(jQuery('.slidedeck-layerpro').find('.sdlcycle-slide'));
                                window.Sdl.animateLayers( $nextSlide );
                                
                            }
                        }
                         $.fn.sdlcycle.transitions.fadeTransition = {

                            before: function( b, c, d, e ) {
                                var f = b.API.getSlideOpts(b.nextSlide).slideCss || {};
                                b.API.stackSlides(c, d, e), b.cssBefore = $.extend(f, {
                                    opacity: 0,
                                    visibility: "visible",
                                    display: "block"
                                }), b.animIn = {
                                    opacity: 1
                                }, b.animOut = {
                                    opacity: 0
                                }

                                var $nextSlide = jQuery('.slidedeck-layerpro').find('.sdlcycle-slide-active');
                                $nextSlide = ! $nextSlide.length ?  jQuery('.slidedeck-layerpro').find('li.slide').eq(1) : $nextSlide;
                                //window.Sdl.addImageCSS(jQuery('.slidedeck-layerpro').find('.sdlcycle-slide-active').prev());
                                window.Sdl.addImageCSS(jQuery('.slidedeck-layerpro').find('.sdlcycle-slide'));
                                window.Sdl.animateLayers( $nextSlide );
                                /*
                                setTimeout(function(){ 
                                    window.Sdl.addImageCSS( $nextSlide );
                                }, 3000);
                                */
                                // assign properties to the opts object
                            },
                            after: function( opts, curr, next, fwd ) {
                                // assign properties to the opts object
                                var $nextSlide = jQuery('.slidedeck-layerpro').find('.sdlcycle-slide-active');
                                $nextSlide = ! $nextSlide.length ?  jQuery('.slidedeck-layerpro').find('li.slide').eq(1) : $nextSlide;
                                window.Sdl.addImageCSS(jQuery('.slidedeck-layerpro').find('.sdlcycle-slide'));
                                //window.Sdl.addImageCSS(jQuery('.slidedeck-layerpro').find('.sdlcycle-slide-active').next());
                                window.Sdl.animateLayers( $nextSlide );
                                /*
                                setTimeout(function(){ 
                                    window.Sdl.addImageCSS( $nextSlide );
                                }, 3000);
                                */
                            }
                        }
                        var fx_value =  'fadeTransition'; 
                        if(this.options.slideTransition){
                            
                          if(this.options.slideTransition === 'scrollHorz'){
                            fx_value = 'scrollTransition';
                          } 
                          else if(this.options.slideTransition === 'fade'){
                              fx_value =  'fadeTransition';
                          } 
                        }

				var cycleOptions = {
						slides  : '>li',
						next    : '.slidedeck-layerpro .deck-navigation.horizontal.next',
						prev    : '.slidedeck-layerpro .deck-navigation.horizontal.prev',
						paused  : this.options.autoPlay ? false : true,
						log     : false,
						fx      : fx_value,
						loop    : this.options.cycle ? 0 : 1, //Loop Playback
						speed   : this.options.speed ? parseInt(this.options.speed) : 1000, //Animation Speed
						timeout : this.options.autoPlayInterval ? parseInt(this.options.autoPlayInterval) * 1000 : 3000, //Autoplay Interval
						swipe 	: this.options.touch ? true : false
                                                
				};

				this.$slidedeck.sdlcycle( cycleOptions );
                                
				this.addHoverClass();

			}
			catch(error)
			{
				console.log(error, "Important: Its not an error, its just a catch notice.");
			}

		},

		createMouseLayerPro : function(  ){
			var $scene, $image, src, layerpro;

			var $slidedeck = $('.lens-layerpro');

			if( ! $slidedeck.length ) return;

			$('.slidedeck-layerpro').addClass('sdl-layerpro-active');

			$slidedeck.find('.slide').each(function(){
				if( ! $(this).hasClass('cycle-sentinel') ){
					$scene = $(this).find('.sdl-layers.layerpro-type-layermove');
					layerpro = $scene.layerpro();
				}
			});
		},

		createScrollLayerPro : function(){
			var $image, src, extra, scrollTop, $slideImage, topOffset, difference, half;

			var $slidedeck = $('.lens-layerpro');

			if( ! $slidedeck.length ) return;

			$('.slidedeck-layerpro').addClass('sdl-layerpro-active');

			$slidedeck.find('.slide').each(function(){
				if( ! $(this).hasClass('cycle-sentinel') ){

					if( $(this).find('.layerpro-type-scroll').length ){

						$image      = $(this).find('img.sd2-slide-background');
						src         = $image.data('fullsrc');
						extra       = 50;
						scrollTop   = $(window).scrollTop();
						$slideImage = $(this).find('img.sd2-slide-background');
						topOffset   = $(this).offset().top - extra;

						if ( topOffset < scrollTop )
						{
							difference = scrollTop  - topOffset;
							half       = (difference / 2) + 'px';
							$slideImage.css('top', half);
						}
						else
						{
							$slideImage.css('top', '0');
						}

					}
				}
			});

		},

		showHideLayers : function( index )
		{
			var $slides = this.$slidedeck.find('.slide').not('.cycle-sentinel');
			var _this = this;

			if( typeof index === 'undefined' ){
				this.fadeIn( $slides.find('.sdl-layers') );
			}
			else{
				var $currentSlide = $slides.eq(index);
				this.fadeOut( $slides.not($currentSlide).find('.sdl-layers') );
				$currentSlide.find('.sdl-layers').hide();
				setTimeout(function(){
					_this.fadeIn( $currentSlide.find('.sdl-layers') );
				}, 1500 );
			}

		},

		fadeIn : function( $el ){
			$el.removeClass('fadeIn-animated fadeIn fadeOut fadeOut-animated');
			$el.show().addClass('fadeIn-animated fadeIn');
		},

		fadeOut : function( $el ){
			$el.removeClass('fadeIn-animated fadeIn fadeOut fadeOut-animated');
			$el.addClass('fadeOut-animated fadeOut');
		},

                addImageCSS : function( $sd )
                {
                    
	    	var $slidedeck = $('.lens-layerpro');
	    	var layerWidth, slidedeckWidth, widthInPercentage, left, top, zIndex, rotate, scale, scalex, scaley, skew, skewx, skewy, rotatex, rotatey,font, family, color, background, bkgwidth, bkgheight, radius, fstyle, fweight;
                if($sd == true){
	    	$slidedeck.each(function(){

	    		slidedeckWidth = $(window).width();

	    		$(this).find('.sdl-slide-layer').each(function(){

					layerWidth        = $(this).find('img').attr('width');
					widthInPercentage = $(this).data('width');//( layerWidth / slidedeckWidth ) * 100;
					left              = $(this).data('offsetx') > -1 ? $(this).data('offsetx') : 20;
					top               = $(this).data('offsety') > -1 ? $(this).data('offsety') : 20;
					zIndex            = $(this).data('z-index') ? $(this).data('z-index') : 20;
                                        rotate            = $(this).data('rotate') ? 'rotate('+$(this).data('rotate')+'deg)' : '';
                                        skewx              = $(this).data('skewx') ? $(this).data('skewx') : '';
                                        skewy           = $(this).data('skewy') ? $(this).data('skewy') : '';
                                        skew            = 'skew('+$(this).data('skewx')+'deg ,'+$(this).data('skewy')+'deg)';
                                        skew = 'skew(0deg,0deg)';
                                        scale            = $(this).data('scale') ? 'scale('+$(this).data('scale')+','+$(this).data('scale')+')' : '';
                                        font            = $(this).data('font') ? $(this).data('font') : '';
                                        var font1 = ((100/document.documentElement.clientWidth)*font)+'vw';
                                        family            = $(this).data('family') ? $(this).data('family') : '';
                                        color            = $(this).data('color') ? $(this).data('color') : '';
                                        background       = $(this).data('background') ? $(this).data('background') : '';
                                         bkgwidth       = $(this).data('bkgwidth') ? $(this).data('bkgwidth') : '';
                                         bkgheight       = $(this).data('bkgheight') ? $(this).data('bkgheight') : '';
                                         radius       = $(this).data('radius') ? $(this).data('radius') : '';
                                         fstyle       = $(this).data('fstyle') ? $(this).data('fstyle') : '';
                                         fweight       = $(this).data('fweight') ? $(this).data('fweight') : '';
	    			$(this).find('img').css( {
	    				'width' : widthInPercentage,
	    				'z-index' : zIndex,
	    				'left' : left + 'px',
	    				'top' : top + 'px',
                                        '-webkit-transform' : rotate + ' ' +  scale + ' ' + skew,
                                        'transform' : rotate + ' ' + scale + ' ' + skew,
                                        'opacity' : 0
	    			});
                                $(this).find('.sd_text_value').css( {
                                       'z-index' : zIndex,
                                       'left' : left + 'px',
                                       'top' : top + 'px',
                                       '-webkit-transform' : rotate + ' ' +  scale + ' ' + skew,
                                       'transform' : rotate + ' ' + scale + ' ' + skew,
                                        'opacity'   : 0,
                                        'position' :'absolute',
                                        //'position' :'relative',
                                        'font-family': family,
                                        'font-size'  : font + 'px',
                                        'color'      : color,
                                        'background' : background,
                                        'width' : bkgwidth + '%',
                                        'height' : bkgheight + '%',
                                        'border-radius' : radius + '%',
                                        'text-align' : 'center',
                                        'font-style' : fstyle,
                                        'font-weight' : fweight
                               });

	    		});
	    	});
            }
            else{
                $sd.find('.sdl-slide-layer').each(function(){
                    layerWidth        = $(this).find('img').attr('width');
                    widthInPercentage = $(this).data('width');//( layerWidth / slidedeckWidth ) * 100;
                    left              = $(this).data('offsetx') ? $(this).data('offsetx') : 20;
                    top               = $(this).data('offsety') ? $(this).data('offsety') : 20;
                    zIndex            = $(this).data('z-index') ? $(this).data('z-index') : 20;
                    rotate            = $(this).data('rotate') ? 'rotate('+$(this).data('rotate')+'deg)' : '';
                    skewx              = $(this).data('skewx') ? $(this).data('skewx') : '';
                    skewy           = $(this).data('skewy') ? $(this).data('skewy') : '';
                    skew            = 'skew('+$(this).data('skewx')+'deg ,'+$(this).data('skewy')+'deg)';
                    skew = 'skew(0deg,0deg)';
                    scale            = $(this).data('scale') ? 'scale('+$(this).data('scale')+','+$(this).data('scale')+')' : '';
                    
                    font            = $(this).data('font') ? $(this).data('font') : '';
                    var font1 = ((100/document.documentElement.clientWidth)*font)+'vw';
                    family            = $(this).data('family') ? $(this).data('family') : '';
                    color            = $(this).data('color') ? $(this).data('color') : '';
                    background            = $(this).data('background') ? $(this).data('background') : '';
                     bkgwidth            = $(this).data('bkgwidth') ? $(this).data('bkgwidth') : '';
                     bkgheight            = $(this).data('bkgheight') ? $(this).data('bkgheight') : '';
                     radius            = $(this).data('radius') ? $(this).data('radius') : '';
                     fstyle       = $(this).data('fstyle') ? $(this).data('fstyle') : '';
                    fweight       = $(this).data('fweight') ? $(this).data('fweight') : '';
                    $(this).find('img').css( {
                            'width' : widthInPercentage,
                            'z-index' : zIndex,
                            'left' : left + '%',
                            'top' : top + '%',
                            '-webkit-transform' : rotate + ' ' +  scale + ' '+ skew,
                            'transform' : rotate + ' ' + scale + ' ' + skew,
                            'opacity'   : 0,
                            'transition' : 'none'
                    });
                    $(this).find('.sd_text_value').css( {
                            'z-index' : zIndex,
                            'left' : left + '%',
                            'top' : top + '%',
                            '-webkit-transform' : rotate + ' ' +  scale + ' ' + skew,
                            'transform' : rotate + ' ' + scale + ' ' + skew,
                            'opacity'   : 0,
                            'font-family': family,
                            'font-size'  : font + 'px',
                            'color'      : color,
                            'background' : background,
                            'width' : bkgwidth + '%',
                            'height' : bkgheight + '%',
                            'border-radius' : radius + '%',
                            'position' :'absolute',
                            'text-align' : 'center',
                            'transition' : 'none',
                            'font-style' : fstyle,
                            'font-weight' : fweight
                    });
                    

                });
            }

	    },

            animateLayers : function( $current_slide ){
                var $options = {};
                $current_slide.find('.sdl-slide-layer').each(function(){
                    var $sd_data = $(this).data();
                    
             
                    var $img = $(this).find('img');
                    var $span = $(this).find('.sd_text_value');
                    
                    var $sd_css = window.Sdl.applyCssToLayer($sd_data);
                   if($img !== undefined){
                       $sd_css['position'] = 'absolute';
                       $img.css($sd_css);
                   }
                   if($span !== undefined){
                       $sd_css['position'] = 'absolute';
                        $sd_css['display'] = 'inline-block';
                        $span.css($sd_css);
                    }
                    
                    // code for each layer for transition out
                    $img.on('transitionend webkitTransitionEnd oTransitionEnd otransitionend MSTransitionEnd', 
                    function() {
                        if($sd_data['durationo'] !== '' && $sd_data['durationo'] !== '0') {
                         var $sd_out_css = window.Sdl.applyOutCssToLayer($sd_data);
                         
                        if($img !== undefined){
                             $sd_out_css['position'] = 'absolute';
                             $img.css($sd_out_css);
                         }
                         if($span !== undefined){
                             $sd_out_css['position'] = 'absolute';
                              $sd_out_css['display'] = 'inline-block';
                              $span.css($sd_out_css);
                          }
                          }
                    });
                    $span.on('transitionend webkitTransitionEnd oTransitionEnd otransitionend MSTransitionEnd', 
                    function() {
                        if($sd_data['durationo'] !== '' && $sd_data['durationo'] !== '0') {
                            var $sd_out_css = window.Sdl.applyOutCssToLayer($sd_data);
                            
                        if($img !== undefined){
                             $sd_out_css['position'] = 'absolute';
                             $img.css($sd_out_css);
                         }
                         if($span !== undefined){
                             $sd_out_css['position'] = 'absolute';
                              $sd_out_css['display'] = 'inline-block';
                              $span.css($sd_out_css);
                          }
                        }
                         
                    });
                    /*
                    if($sd_data['durationo'] !== '' && $sd_data['durationo'] !== '0') {
                        var delay = $sd_data['durationo'];
                        
                        setTimeout(function(){ 
                           var $sd_out_css = window.Sdl.applyOutCssToLayer($sd_data);
                           if($img !== undefined){
                                $sd_out_css['position'] = 'absolute';
                                $img.css($sd_out_css);
                            }
                            if($span !== undefined){
                                $sd_out_css['position'] = 'absolute';
                                 $sd_out_css['display'] = 'inline-block';
                                 $span.css($sd_out_css);
                             }
                        }, delay);
                    }
                    */
                    
                    
                });
                
            },
            applyOutCssToLayer : function($sd_data){
            
              var $sd_css = {};
              var tempx = '100px';
              var tempy = '100px';
              $.each($sd_data, function($key, $value){
                    switch($key){
                        
                        case 'rotateo':
                            if($value !== '') {
                                $sd_css['-webkit-transform'] = 'rotate('+$value+'deg)';//"'-webkit-transform': 'rotate("+$value+"deg)','transform': 'rotate("+$value+"deg)'";
                                $sd_css['transform'] = 'rotate('+$value+'deg)';
                            }
                            
                        break;                        
                        case 'scaleo':
                            
                            if($value !== ''){
                                if($sd_css['transform'] === undefined)
                                    $sd_css['transform'] = 'scale('+$value+')';
                                else
                                    $sd_css['transform'] += ' scale('+$value+')';
                                
                                if($sd_css['-webkit-transform'] === undefined)
                                    $sd_css['-webkit-transform'] = 'scale('+$value+')';
                                else
                                    $sd_css['-webkit-transform'] += ' scale('+$value+')';
                                
                                if($sd_css['-o-transform'] === undefined)
                                    $sd_css['-o-transform'] = 'scale('+$value+')';
                                else
                                    $sd_css['-o-transform'] += ' scale('+$value+')';
                            }                           
                        break;
                        
                        case 'skewxo':
                            
                            if($value !== ''){
                                if($sd_css['transform'] === undefined)
                                    $sd_css['transform'] = 'skewx('+$value+'deg)';
                                else
                                    $sd_css['transform'] += ' skewx('+$value+'deg)';
                                
                                if($sd_css['-webkit-transform'] === undefined)
                                    $sd_css['-webkit-transform'] = 'skewx('+$value+'deg)';
                                else
                                    $sd_css['-webkit-transform'] += ' skewx('+$value+'deg)';
                                
                                if($sd_css['-o-transform'] === undefined)
                                    $sd_css['-o-transform'] = 'skewx('+$value+'deg)';
                                else
                                    $sd_css['-o-transform'] += ' skewx('+$value+'deg)';
                            }
                            
                        break;
                        case 'skewyo':
                            if($value !== ''){
                                if($sd_css['transform'] === undefined)
                                    $sd_css['transform'] = 'skewy('+$value+'deg)';
                                else
                                    $sd_css['transform'] += ' skewy('+$value+'deg)';
                                
                                if($sd_css['-webkit-transform'] === undefined)
                                    $sd_css['-webkit-transform'] = 'skewy('+$value+'deg)';
                                else
                                    $sd_css['-webkit-transform'] += ' skewy('+$value+'deg)';
                                
                                if($sd_css['-o-transform'] === undefined)
                                    $sd_css['-o-transform'] = 'skewy('+$value+'deg)';
                                else
                                    $sd_css['-o-transform'] += ' skewy('+$value+'deg)';
                            }                           
                        break;
                        case 'delayo':
                        	if($sd_css['transition-delay'] === undefined)
                                $sd_css['transition-delay'] = $value+'ms';
                        	else
                                $sd_css['transition-delay'] += ' '+$value+'ms';
                        break;
                        case 'durationo':
                            if($sd_css['transition-duration'] === undefined)
                                    $sd_css['transition-duration'] = $value+'ms';
                                else
                                    $sd_css['transition-duration'] += ' '+$value+'ms';
                        break;
                        case 'easeo':
                            switch($value) {
                                case 'easeInSine' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.47, 0, 0.745, 0.715)';
                                    break;
                                case 'easeOutSine' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.39, 0.575, 0.565, 1)';
                                    break;
                                case 'easeInOutSine' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.445, 0.05, 0.55, 0.95)';
                                    break;
                                case 'easeInQuad' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.55, 0.085, 0.68, 0.53)';
                                    break;
                                case 'easeOutQuad' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.25, 0.46, 0.45, 0.94)';
                                    break;
                                case 'easeInOutQuad' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.455, 0.03, 0.515, 0.955)';
                                    break;
                                case 'easeInCubic' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.55, 0.055, 0.675, 0.19)';
                                    break;
                                case 'easeOutCubic' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.215, 0.61, 0.355, 1)';
                                    break;
                                case 'easeInOutCubic' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.645, 0.045, 0.355, 1)';
                                    break;
                                case 'easeInQuart' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.895, 0.03, 0.685, 0.22)';
                                    break;
                                case 'easeOutQuart' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.165, 0.84, 0.44, 1)';
                                    break;
                                case 'easeInOutQuart' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.77, 0, 0.175, 1)';
                                    break; 
                                case 'easeInQuint' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.755, 0.05, 0.855, 0.06)';
                                    break;
                                case 'easeOutQuint' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.23, 1, 0.32, 1)';
                                    break;
                                case 'easeInOutQuint' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.86, 0, 0.07, 1)';
                                    break; 
                                case 'easeInExpo' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.95, 0.05, 0.795, 0.035)';
                                    break;
                                case 'easeOutExpo' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.19, 1, 0.22, 1)';
                                    break;
                                case 'easeInOutExpo' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(1, 0, 0, 1)';
                                    break;
                                case 'easeInCirc' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.6, 0.04, 0.98, 0.335)';
                                    break;
                                case 'easeOutCirc' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.075, 0.82, 0.165, 1)';
                                    break;
                                case 'easeInOutCirc' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.785, 0.135, 0.15, 0.86)';
                                    break;
                                case 'easeInBack' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.6, -0.28, 0.735, 0.045)';
                                    break;
                                case 'easeOutBack' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.175, 0.885, 0.32, 1.275)';
                                    break;
                                case 'easeInOutBack' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.68, -0.55, 0.265, 1.55)';
                                    break;
                                default :
                                    $sd_css['transition-ease'] = $value;
                            }
                        break;                                              
                        case 'offsetxo':
                            tempx = $value+'%';
                        break;
                        case 'offsetyo':
                            tempy = $value+'%';
                        break;                       
                        case 'family':
                            $sd_css['font-family'] = $value;
                        break;                       
                        case 'font':
                            $sd_css['font-size'] = $value;
                        break;      
                        case 'color':
                            $sd_css['color'] = $value;
                        break;
                        case 'background' : 
                            $sd_css['background'] = $value; 
                        break;
                        case 'bkgwidth' : 
                            $sd_css['bkgwidth'] = $value;
                        break;
                        case 'bkgheight' :  
                            $sd_css['bkgheight'] = $value;
                        break;
                        case 'radius' :  
                            $sd_css['radius'] = $value; 
                        break;
                        case 'fstyle' : 
                            $sd_css['fstyle'] = $value;
                        break;
                        case 'fweight' : 
                            $sd_css['fweight'] = $value;
                            break;
                        case 'cordinates':
                            if(cordinates[0] !== undefined)
                                tempx = $value+'%';
                            else if(cordinates[1] !== undefined)
                                tempy = $value+'%';
                        break;
                    }
            });
            $sd_css['transition'] = 'all '+$sd_css['transition-delay']+' '+$sd_css['transition-ease']+' '+$sd_css['transition-duration'];
            $sd_css['left'] = tempx;
            $sd_css['top'] = tempy;
            $sd_css['position'] = 'absolute';
            $sd_css['opacity'] = 1;
            
              return $sd_css;
            },
            applyCssToLayer : function($sd_data){
              
              var $sd_css = {};
              var tempx = '100px';
              var tempy = '100px';
              $.each($sd_data, function($key, $value){
                    switch($key){
                        
                        case 'rotate':
                            $sd_css['-webkit-transform'] = 'rotate(0deg)';//"'-webkit-transform': 'rotate("+$value+"deg)','transform': 'rotate("+$value+"deg)'";
                            $sd_css['transform'] = 'rotate(0deg)';
                        break;                        
                        case 'scale':
                            if($value !== ''){
                                if($sd_css['transform'] === undefined)
                                    $sd_css['transform'] = 'scale(1)';
                                else
                                    $sd_css['transform'] += ' scale(1)';
                                
                                if($sd_css['-webkit-transform'] === undefined)
                                    $sd_css['-webkit-transform'] = 'scale(1)';
                                else
                                    $sd_css['-webkit-transform'] += ' scale(1)';
                                
                                if($sd_css['-o-transform'] == undefined)
                                    $sd_css['-o-transform'] = 'scale(1)';
                                else
                                    $sd_css['-o-transform'] += ' scale(1)';
                            }                           
                        break;
                        
                        case 'skewx':
                            if($value !== ''){
                                if($sd_css['transform'] === undefined)
                                    $sd_css['transform'] = 'skewx('+$value+'deg)';
                                else
                                    $sd_css['transform'] += ' skewx('+$value+'deg)';
                                
                                if($sd_css['-webkit-transform'] === undefined)
                                    $sd_css['-webkit-transform'] = 'skewx('+$value+'deg)';
                                else
                                    $sd_css['-webkit-transform'] += ' skewx('+$value+'deg)';
                                
                                if($sd_css['-o-transform'] === undefined)
                                    $sd_css['-o-transform'] = 'skewx('+$value+'deg)';
                                else
                                    $sd_css['-o-transform'] += ' skewx('+$value+'deg)';
                            }                           
                        break;
                        case 'skewy':
                            if($value !== ''){
                                if($sd_css['transform'] === undefined)
                                    $sd_css['transform'] = 'skewy('+$value+'deg)';
                                else
                                    $sd_css['transform'] += ' skewy('+$value+'deg)';
                                
                                if($sd_css['-webkit-transform'] === undefined)
                                    $sd_css['-webkit-transform'] = 'skewy('+$value+'deg)';
                                else
                                    $sd_css['-webkit-transform'] += ' skewy('+$value+'deg)';
                                
                                if($sd_css['-o-transform'] === undefined)
                                    $sd_css['-o-transform'] = 'skewy('+$value+'deg)';
                                else
                                    $sd_css['-o-transform'] += ' skewy('+$value+'deg)';
                            }                           
                        break;
                        case 'delay':
                        	if($sd_css['transition-delay'] === undefined)
                                $sd_css['transition-delay'] = $value+'ms';
                        	else
                                $sd_css['transition-delay'] += ' '+$value+'ms';
                        break;
                        case 'duration':
                            if($sd_css['transition-duration'] === undefined)
                                    $sd_css['transition-duration'] = $value+'ms';
                                else
                                    $sd_css['transition-duration'] += ' '+$value+'ms';
                        break;
                        case 'ease':
                            switch($value) {
                                case 'easeInSine' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.47, 0, 0.745, 0.715)';
                                    break;
                                case 'easeOutSine' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.39, 0.575, 0.565, 1)';
                                    break;
                                case 'easeInOutSine' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.445, 0.05, 0.55, 0.95)';
                                    break;
                                case 'easeInQuad' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.55, 0.085, 0.68, 0.53)';
                                    break;
                                case 'easeOutQuad' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.25, 0.46, 0.45, 0.94)';
                                    break;
                                case 'easeInOutQuad' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.455, 0.03, 0.515, 0.955)';
                                    break;
                                case 'easeInCubic' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.55, 0.055, 0.675, 0.19)';
                                    break;
                                case 'easeOutCubic' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.215, 0.61, 0.355, 1)';
                                    break;
                                case 'easeInOutCubic' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.645, 0.045, 0.355, 1)';
                                    break;
                                case 'easeInQuart' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.895, 0.03, 0.685, 0.22)';
                                    break;
                                case 'easeOutQuart' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.165, 0.84, 0.44, 1)';
                                    break;
                                case 'easeInOutQuart' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.77, 0, 0.175, 1)';
                                    break; 
                                case 'easeInQuint' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.755, 0.05, 0.855, 0.06)';
                                    break;
                                case 'easeOutQuint' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.23, 1, 0.32, 1)';
                                    break;
                                case 'easeInOutQuint' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.86, 0, 0.07, 1)';
                                    break; 
                                case 'easeInExpo' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.95, 0.05, 0.795, 0.035)';
                                    break;
                                case 'easeOutExpo' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.19, 1, 0.22, 1)';
                                    break;
                                case 'easeInOutExpo' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(1, 0, 0, 1)';
                                    break;
                                case 'easeInCirc' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.6, 0.04, 0.98, 0.335)';
                                    break;
                                case 'easeOutCirc' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.075, 0.82, 0.165, 1)';
                                    break;
                                case 'easeInOutCirc' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.785, 0.135, 0.15, 0.86)';
                                    break;
                                case 'easeInBack' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.6, -0.28, 0.735, 0.045)';
                                    break;
                                case 'easeOutBack' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.175, 0.885, 0.32, 1.275)';
                                    break;
                                case 'easeInOutBack' : 
                                    $sd_css['transition-ease'] = 'cubic-bezier(0.68, -0.55, 0.265, 1.55)';
                                    break;
                                default :
                                    $sd_css['transition-ease'] = $value;
                            }
                        break;                                              
                        case 'positionX':
                            tempx = $value+'%';
                        break;
                        case 'positionY':
                            tempy = $value+'%';
                        break;                       
                        case 'family':
                            $sd_css['font-family'] = $value;
                        break;                       
                        case 'font':
                            $sd_css['font-size'] = $value;
                        break;      
                        case 'color':
                            $sd_css['color'] = $value;
                        break;
                        case 'background' : 
                            $sd_css['background'] = $value; 
                        break;
                        case 'bkgwidth' : 
                            $sd_css['bkgwidth'] = $value;
                        break;
                        case 'bkgheight' :  
                            $sd_css['bkgheight'] = $value;
                        break;
                        case 'radius' :  
                            $sd_css['radius'] = $value; 
                        break;
                        case 'fstyle' :  
                            $sd_css['fstyle'] = $value; 
                        break;
                        case 'fweight' :  
                            $sd_css['fweight'] = $value; 
                        break;
                        case 'cordinates':
                            if(cordinates[0] !== undefined)
                                tempx = $value+'%';
                            else if(cordinates[1] !== undefined)
                                tempy = $value+'%';
                        break;
                    }
            });
            $sd_css['transition'] = 'all '+$sd_css['transition-delay']+' '+$sd_css['transition-ease']+' '+$sd_css['transition-duration'];
            $sd_css['left'] = tempx;
            $sd_css['top'] = tempy;
            $sd_css['position'] = 'absolute';
            $sd_css['opacity'] = 1;
              return $sd_css;
            }
           
	};

    $(document).ready(function(){
        $('.slidedeck-layerpro-lens').each(function(){
            window.Sdl.init(this.id);
        });
    });

        $(window).on('resize', function(){
            var win = $(this); //this = window
            if (win.height() >= 820) { 
                /* ... */
                
            }
            if (win.width() >= 1280) { 
                /* ... */ 
                
            }
        });
});
