(function($){
	var ajaxOptions = [
        "options[navigation-type]",
        "options[thumbnailHeight]",
        "options[show-title]",
        "options[show-author]",
        "options[date-format]",
        "options[titleTransition]"
	];
	
	for(i = 0; i < ajaxOptions.length; i++){
		// Apply Ajax Updates to these...
		SlideDeckPreview.updates[ajaxOptions[i]] = function($elem, value){
	    	SlideDeckPreview.ajaxUpdate();
	    };		
		
		SlideDeckPreview.ajaxOptions.push(ajaxOptions[i]);
	}
	
    SlideDeckPreview.updates['options[lensVariations]'] = function($elem, value){
    	var accentColorInput = $('#options-accentColor');
    	var swatch = $('.miniColors-trigger');
    	var colors = {
    		light: '#111111',
    		dark: '#ffffff'
    	};
    	
    	// Use Raphaelto check the hex value against the defaults
    	hexColor = Raphael.color( swatch.css('background-color') ).hex;
    	
    	// iterate through the pre defined colors...
		for (var key in colors ) {
			/**
			 * If the currently selected color is one of the pre defined
			 * colors, then we need to switch it to the other readable value.
			 */
			if( hexColor == colors[key] ){
				accentColorInput.val( colors[value] ).change();
				swatch.css( { 'background-color': colors[value] } );
			}
			
			// Remove all the color classes. 
			var color = colors[key];
			SlideDeckPreview.elems.slidedeckFrame.removeClass(SlideDeckPrefix + key);
		};
		
		// Add the new color class.
		SlideDeckPreview.elems.slidedeckFrame.addClass(SlideDeckPrefix + value);
		
    };
	
})(jQuery);