

jQuery(function($){

	"use strict";

	if( window.Sdtp !== undefined ) return;

	window.Sdtp = {

		$slidedeck : $('.slidedeck-transitionpro-lens'),
		options : {},
                //$next : $('.slidedeck-transitionpro .deck-navigation.horizontal.next'),
                //$prev : $('.slidedeck-transitionpro .deck-navigation.horizontal.prev'),

		init : function(){
			if( this.$slidedeck === undefined ) return;
			this.createSlider();
			// this.createMouseTransitionpro();
			this.events();
                        this.showSlidedeck();
                        this.addImageCSS();
		},

		events : function(){
			//this.$slidedeck.on( 'sdcycle-next', this.next );
			//this.$slidedeck.on( 'sdcycle-prev', this.prev );
			// $(window).on( 'load', this.showSlidedeck );
			// $(window).on( 'load', this.addImageCSS );
			$(document).on( 'keyup', this.keyboard );
		},

		showSlidedeck : function(){
			var _this = Sdtp;
			$('.slidedeck-transitionpro.sdtp-loading').removeClass('sdtp-loading');
			$(window).on('scroll', _this.createScrollTransitionpro );
		},

		addNavMarkup : function( $slide, $el ){
			var imageSrc = $slide.find('.sd2-slide-background').data('fullsrc');
			$el.html( "<span class='sdtp-nav-icon'></span><img src='" + imageSrc + "'>" );
		},

		addNextNav : function( next ){
			var $nextSlide = this.$slidedeck.find('.sdcycle-slide-active').next();
			$nextSlide = ! $nextSlide.length ? this.$slidedeck.find('li.slide').eq(1) : $nextSlide;
			this.addNavMarkup( $nextSlide, this.$next );
		},

		addPrevNav : function( currentIndex ){
			var $prevSlide = this.$slidedeck.find('.sdcycle-slide-active').prev();
			if( $prevSlide.hasClass('.sdcycle-sentinel') ){
				$prevSlide = this.$slidedeck.find('li.slide').last();
			}
			this.addNavMarkup( $prevSlide, this.$prev );
		},

		next : function( event, obj ){
			//Sdtp.addNextNav();
		},

		prev : function( event, obj ){
			//Sdtp.addPrevNav();
		},

		keyboard : function(event){

			var $slider = Sdtp.$slidedeck;

			if( ! $slider.length || ! Sdtp.options.keys  ) return;

			if (event.keyCode == 37) {
	           jQuery('.skitter-large').skitter('prev');
	        } else if (event.keyCode == 39) {
	           jQuery('.skitter-large').skitter('next');
		    }
		},

		addHoverClass : function(){
			var options = this.getSliderOptions();
			if( options.display_nav_arrows ){
				$('.slidedeck-transitionpro').addClass( 'sdtp-arrow-' + options.display_nav_arrows );
			}
		},

		getSliderOptions : function(){
			var $el;
			this.$slidedeck.find('.slide').each(function(){
				if( $(this).find('ul.sdtp-layers').length ){
					$el = $(this).find('ul.sdtp-layers');
				}
			});

			if( $el === undefined ) return {};

			return {
				'continueScrolling'  : $el.data('continuescrolling'),
				'autoPlay'           : $el.data('autoplay'),
				'autoPlayInterval'   : $el.data('autoplayinterval'),
				'cycle'              : $el.data('cycle'),
				'slideTransition'    : $el.data('slidetransition'),
				'speed'              : $el.data('speed'),
				'keys'               : $el.data('keys'),
				'touch'              : $el.data('touch'),
				'scroll'             : $el.data('scroll'),
				'start'              : $el.data('start'),
				'display_nav_arrows' : $el.data('display-nav-arrows'),
                                'navigation_type'        : $el.data('navigation_type'),
                                'navigation'        : $el.data('navigation'),
                                'progressbar'        : $el.data('progressbar'),
                                
			};
		},

		createSlider : function(){

			try{
                                var dot_nav=false,number_nav=false,thumb_nav=false; 
				this.options = this.getSliderOptions();
                                if(this.options.navigation_type === 'nav-dots') {
                                    dot_nav = true;
                                } else if(this.options.navigation_type === 'nav-number'){
                                    number_nav = true;
                                } else if(this.options.navigation_type === 'nav-thumb'){
                                    thumb_nav = true;
                                }
                                
				var skitterOptions = {
						slides  : '>li',
						next    : '.deck-navigation.horizontal.next',
						prev    : '.deck-navigation.horizontal.prev',
						auto_play  : this.options.autoPlay ? true : false,
						log     : false,
						animation      : this.options.slideTransition ? this.options.slideTransition : 'tileSlide',
						loop    : this.options.cycle ? 0 : 1, //Loop Playback
						speed   : this.options.speed ? parseInt(this.options.speed) : 1000, //Animation Speed
						interval : this.options.autoPlayInterval ? parseInt(this.options.autoPlayInterval) * 1000 : 3000, //Autoplay Interval
                                                navigation: this.options.navigation ? true : false,
                                                numbers: number_nav?true:false,
                                                dots: dot_nav?true:false,
                                                thumbs: thumb_nav?true:false,
                                                progressbar: this.options.progressbar ? true : false,
                                                touch : this.options.touch? true:false,
				};
                                jQuery('.skitter-large').skitter(skitterOptions);
				//this.$slidedeck.sdcycle( cycleOptions );

				this.addHoverClass();

			}
			catch(error)
			{
				console.log(error, "Important: Its not an error, its just a catch notice.");
			}

		},

		createMouseTransitionpro : function(  ){
			var $scene, $image, src, transitionpro;

			var $slidedeck = $('.lens-transitionpro');

			if( ! $slidedeck.length ) return;

			$('.slidedeck-transitionpro').addClass('sdtp-transitionpro-active');

			$slidedeck.find('.slide').each(function(){
				if( ! $(this).hasClass('cycle-sentinel') ){
					$scene = $(this).find('.sdtp-layers.transitionpro-type-mousemove');
					transitionpro = $scene.transitionpro();
				}
			});
		},

		createScrollTransitionpro : function(){
			var $image, src, extra, scrollTop, $slideImage, topOffset, difference, half;

			var $slidedeck = $('.lens-transitionpro');

			if( ! $slidedeck.length ) return;

			$('.slidedeck-transitionpro').addClass('sdtp-transitionpro-active');

			$slidedeck.find('.slide').each(function(){
				if( ! $(this).hasClass('cycle-sentinel') ){

					if( $(this).find('.transitionpro-type-scroll').length ){

						$image      = $(this).find('img.sd2-slide-background');
						src         = $image.data('fullsrc');
						extra       = 50;
						scrollTop   = $(window).scrollTop();
						$slideImage = $(this).find('img.sd2-slide-background');
						topOffset   = $(this).offset().top - extra;

						if ( topOffset < scrollTop )
						{
							difference = scrollTop  - topOffset;
							half       = (difference / 2) + 'px';
							$slideImage.css('top', half);
						}
						else
						{
							$slideImage.css('top', '0');
						}

					}
				}
			});

		},

		showHideLayers : function( index )
		{
			var $slides = this.$slidedeck.find('.slide').not('.cycle-sentinel');
			var _this = this;

			if( typeof index === 'undefined' ){
				this.fadeIn( $slides.find('.sdtp-layers') );
			}
			else{
				var $currentSlide = $slides.eq(index);
				this.fadeOut( $slides.not($currentSlide).find('.sdtp-layers') );
				$currentSlide.find('.sdtp-layers').hide();
				setTimeout(function(){
					_this.fadeIn( $currentSlide.find('.sdtp-layers') );
				}, 1500 );
			}

		},

		fadeIn : function( $el ){
			$el.removeClass('fadeIn-animated fadeIn fadeOut fadeOut-animated');
			$el.show().addClass('fadeIn-animated fadeIn');
		},

		fadeOut : function( $el ){
			$el.removeClass('fadeIn-animated fadeIn fadeOut fadeOut-animated');
			$el.addClass('fadeOut-animated fadeOut');
		},

	    addImageCSS : function(){

	    	var $slidedeck = $('.lens-transitionpro');
	    	var layerWidth, slidedeckWidth, widthInPercentage, left, top, zIndex;

	    	$slidedeck.each(function(){

	    		slidedeckWidth = $(window).width();

	    		$(this).find('.sdtp-slide-layer').each(function(){

					layerWidth        = $(this).find('img').attr('width');
					widthInPercentage = ( layerWidth / slidedeckWidth ) * 100;
					left              = $(this).data('position-x') > -1 ? $(this).data('position-x') : 20;
					top               = $(this).data('position-y') > -1 ? $(this).data('position-y') : 20;
					zIndex            = $(this).data('z-index') ? $(this).data('z-index') : 20;

	    			$(this).css( {
	    				'width' : widthInPercentage + '%',
	    				'z-index' : zIndex,
	    				'left' : left + '%',
	    				'top' : top + '%'
	    			});

	    		});
	    	});

	    },


	};

	window.Sdtp.init();

});
